package io.ient.test;

import io.ient.test.context.FrameworkTestBase;
import io.ient.test.facets.Login;
import io.ient.test.framework.selenium.WaitTime;
import io.ient.test.framework.utils.RandomDataUtils;
import io.ient.test.framework.utils.annotations.TestCaseID;
import io.ient.test.pages.HomePage;
import io.ient.test.pages.enterprise.BusinessOrganizationsPage;
import io.ient.test.pages.enterprise.PlantsPage;
import io.ient.test.pages.enterprise.PlantDetailsPage;
import org.testng.annotations.Test;
import org.testng.asserts.SoftAssert;

public class PlantsTest extends FrameworkTestBase {

    @TestCaseID(ids = {"T1400"})
    @Test
    public void verifyNewPlantCreation() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnEnterprise();
        PlantsPage plantsPage = new PlantsPage(driver);
        plantsPage.clickOnPlantsTab();
        String locationName = "AP_" + RandomDataUtils.randomAlphabetic(4);
        String duns = RandomDataUtils.randomNumeric(4);
        String costRecoveryThreshold = RandomDataUtils.randomNumeric(4);
        String defaultCurrency = "XUA";
        String localTimeZone = "Alaska Standard Time (AST)";
        String status = "Active";
        plantsPage.createPlant(locationName, duns, costRecoveryThreshold, defaultCurrency, localTimeZone, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantsPage.searchPlantByLocationName(locationName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayStatus = plantsPage.isPlantDisplayed(locationName);
        softAssert.assertTrue(displayStatus, "Failed to create new plant");
        String updatePlantName = locationName + "_EDIT";
        plantsPage.editPlant(updatePlantName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantsPage.clearLocationNameTextField();
        plantsPage.searchPlantByLocationName(updatePlantName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean updatedPlantDisplayStatus = plantsPage.isPlantDisplayed(updatePlantName);
        softAssert.assertTrue(updatedPlantDisplayStatus, "Failed to update plant");
        plantsPage.deletePlant();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantsPage.clearLocationNameTextField();
        plantsPage.searchPlantByLocationName(updatePlantName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        plantsPage.clickOnSearchIcon();
        boolean isPlantDeleted = plantsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isPlantDeleted, "Failed to delete plant");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"T1401"})
    @Test
    public void verifyNewDepartmentCreationInPlants() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnEnterprise();
        PlantsPage plantsPage = new PlantsPage(driver);
        PlantDetailsPage plantDetailsPage = new PlantDetailsPage(driver);
        plantsPage.clickOnPlantsTab();
        String locationName = "AP_" + RandomDataUtils.randomAlphabetic(4);
        String duns = RandomDataUtils.randomNumeric(4);
        String costRecoveryThreshold = RandomDataUtils.randomNumeric(4);
        String defaultCurrency = "XUA";
        String localTimeZone = "Alaska Standard Time (AST)";
        String status = "Active";
        plantsPage.createPlant(locationName, duns, costRecoveryThreshold, defaultCurrency, localTimeZone, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantsPage.searchPlantByLocationName(locationName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayStatus = plantsPage.isPlantDisplayed(locationName);
        softAssert.assertTrue(displayStatus, "Failed to create new plant");
        plantDetailsPage.clickOnPlantDetailsTab();
        String name = RandomDataUtils.randomAlphabetic(5);
        String code = RandomDataUtils.randomAlphabetic(4);
        String statusD = "Active";
        plantDetailsPage.createDepartment(name, code, statusD);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantDetailsPage.searchDepartmentByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean departmentDisplayStatus = plantDetailsPage.isDepartmentDisplayed(name);
        softAssert.assertTrue(departmentDisplayStatus, "Failed to create new department");
        String updateDepartmentName = name + "_EDIT";
        plantDetailsPage.editDepartment(updateDepartmentName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantDetailsPage.clearNameTextField();
        plantDetailsPage.searchDepartmentByName(updateDepartmentName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean updatedDepartmentDisplayStatus = plantDetailsPage.isDepartmentDisplayed(updateDepartmentName);
        softAssert.assertTrue(updatedDepartmentDisplayStatus, "Failed to update department");
        plantDetailsPage.deleteDepartment();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantDetailsPage.clearNameTextField();
        plantDetailsPage.searchDepartmentByName(updateDepartmentName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        plantDetailsPage.clickOnSearchIcon();
        boolean isDepartmentDeleted = plantDetailsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDepartmentDeleted, "Failed to delete department");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"T1402"})
    @Test
    public void verifyNewPlantLineCreationInPlants() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnEnterprise();
        PlantsPage plantsPage = new PlantsPage(driver);
        PlantDetailsPage plantDetailsPage = new PlantDetailsPage(driver);
        plantsPage.clickOnPlantsTab();
        String locationName = "AP_" + RandomDataUtils.randomAlphabetic(4);
        String duns = RandomDataUtils.randomNumeric(4);
        String costRecoveryThreshold = RandomDataUtils.randomNumeric(4);
        String defaultCurrency = "XUA";
        String localTimeZone = "Alaska Standard Time (AST)";
        String status = "Active";
        plantsPage.createPlant(locationName, duns, costRecoveryThreshold, defaultCurrency, localTimeZone, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantsPage.searchPlantByLocationName(locationName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayStatus = plantsPage.isPlantDisplayed(locationName);
        softAssert.assertTrue(displayStatus, "Failed to create new plant");
        plantDetailsPage.clickOnPlantDetailsTab();
        String name = RandomDataUtils.randomAlphabetic(5);
        String downRate = RandomDataUtils.randomNumeric(2);
        plantDetailsPage.createPlantLIne(name, downRate, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantDetailsPage.searchDepartmentByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean plantLineDisplayStatus = plantDetailsPage.isDepartmentDisplayed(name);
        softAssert.assertTrue(plantLineDisplayStatus, "Failed to create new plant line");
        String updatePlantLineName = name + "_EDIT";
        plantDetailsPage.editPlantLine(updatePlantLineName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantDetailsPage.clearNameTextField();
        plantDetailsPage.searchDepartmentByName(updatePlantLineName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean updatedPlantLineDisplayStatus = plantDetailsPage.isDepartmentDisplayed(updatePlantLineName);
        softAssert.assertTrue(updatedPlantLineDisplayStatus, "Failed to update plant line");
        plantDetailsPage.deletePlantLine();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantDetailsPage.clearNameTextField();
        plantDetailsPage.searchDepartmentByName(updatePlantLineName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        plantDetailsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean isPlantLineDeleted = plantDetailsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isPlantLineDeleted, "Failed to delete plant line");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"T1403"})
    @Test
    public void verifyNewLaborCodeCreationInPlants() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnEnterprise();
        PlantsPage plantsPage = new PlantsPage(driver);
        PlantDetailsPage plantDetailsPage = new PlantDetailsPage(driver);
        plantsPage.clickOnPlantsTab();
        String locationName = "AP_" + RandomDataUtils.randomAlphabetic(4);
        String duns = RandomDataUtils.randomNumeric(4);
        String costRecoveryThreshold = RandomDataUtils.randomNumeric(4);
        String defaultCurrency = "XUA";
        String localTimeZone = "Alaska Standard Time (AST)";
        String status = "Active";
        plantsPage.createPlant(locationName, duns, costRecoveryThreshold, defaultCurrency, localTimeZone, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantsPage.searchPlantByLocationName(locationName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayStatus = plantsPage.isPlantDisplayed(locationName);
        softAssert.assertTrue(displayStatus, "Failed to create new plant");
        plantDetailsPage.clickOnPlantDetailsTab();
        String name = RandomDataUtils.randomAlphabetic(5);
        String code = RandomDataUtils.randomAlphabetic(4);
        String rate = RandomDataUtils.randomNumeric(2);
        plantDetailsPage.createLaborCode(name, code, rate, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantDetailsPage.searchDepartmentByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean laborCodeDisplayStatus = plantDetailsPage.isDepartmentDisplayed(name);
        softAssert.assertTrue(laborCodeDisplayStatus, "Failed to create new labor code");
        String updateLaborCodeName = name + "_EDIT";
        plantDetailsPage.editLaborCodes(updateLaborCodeName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantDetailsPage.clearNameTextField();
        plantDetailsPage.searchDepartmentByName(updateLaborCodeName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean updatedLaborCodeDisplayStatus = plantDetailsPage.isDepartmentDisplayed(updateLaborCodeName);
        softAssert.assertTrue(updatedLaborCodeDisplayStatus, "Failed to update labor code");
        plantDetailsPage.deleteLaborCodes();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantDetailsPage.clearNameTextField();
        plantDetailsPage.searchDepartmentByName(updateLaborCodeName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        plantDetailsPage.clickOnSearchIcon();
        boolean isLaborCodeDeleted = plantDetailsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isLaborCodeDeleted, "Failed to delete labor code");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-193", "IENT-124"})
    @Test
    public void verifyPlantActiveAndInActiveFunctionality() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnEnterprise();
        PlantsPage plantsPage = new PlantsPage(driver);
        plantsPage.clickOnPlantsTab();
        String locationName = "AP_" + RandomDataUtils.randomAlphabetic(4);
        String duns = RandomDataUtils.randomNumeric(4);
        String costRecoveryThreshold = RandomDataUtils.randomNumeric(4);
        String defaultCurrency = "XUA";
        String localTimeZone = "Alaska Standard Time (AST)";
        String status = "Active";
        plantsPage.createPlant(locationName, duns, costRecoveryThreshold, defaultCurrency, localTimeZone, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantsPage.searchPlantByLocationName(locationName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayStatus = plantsPage.isPlantDisplayed(locationName);
        softAssert.assertTrue(displayStatus, "Failed to create new plant");
        boolean displayActiveStatus = plantsPage.isPlantIsActive(locationName, duns);
        softAssert.assertTrue(displayActiveStatus, "Failed to find active plant");
        String inactiveStatus = "Inactive";
        plantsPage.editPlant(locationName, inactiveStatus);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantsPage.clearLocationNameTextField();
        plantsPage.searchPlantByLocationName(locationName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayInactiveStatus = plantsPage.isPlantIsInactive(locationName, duns);
        softAssert.assertTrue(displayInactiveStatus, "Failed to find inactive plant");
        plantsPage.deletePlant();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantsPage.clearLocationNameTextField();
        plantsPage.searchPlantByLocationName(locationName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        plantsPage.clickOnSearchIcon();
        boolean isPlantDeleted = plantsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isPlantDeleted, "Failed to delete plant");
        plantsPage.clickOnAddButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        boolean isSubmitButtonDisabled = plantsPage.isSubmitButtonDisabled();
        softAssert.assertTrue(isSubmitButtonDisabled, "Failed to disable submit button");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-714" , "IENT-724" , "IENT-725"})
    @Test
    public void verifyNewPlantWithBusinessOrganization() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnEnterprise();
        BusinessOrganizationsPage businessOrganizationsPage = new BusinessOrganizationsPage(driver);
        businessOrganizationsPage.clickOnBusinessOrganizationsTab();
        String organizationName = "BO_" + RandomDataUtils.randomNumeric(5);
        String duns = RandomDataUtils.randomNumeric(5);
        String costRecoveryThreshold = RandomDataUtils.randomNumeric(5);
        String defaultCurrency = "XUA";
        String localTimeZone = "Alaska Standard Time (AST)";
        String status = "Active";
        businessOrganizationsPage.createBusinessOrganization(organizationName, duns, costRecoveryThreshold, defaultCurrency, localTimeZone, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        businessOrganizationsPage.clearOrganizationNameTextField();
        businessOrganizationsPage.searchOrganizationByName(organizationName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayStatus = businessOrganizationsPage.isBusinessOrganizationDisplayed(organizationName, duns);
        softAssert.assertTrue(displayStatus, "Failed to create new business organization");
        homePage.clickOnEnterprise();
        PlantsPage plantsPage = new PlantsPage(driver);
        plantsPage.clickOnPlantsTab();
        String locationName = "AP_" + RandomDataUtils.randomAlphabetic(4);
        String plDuns = RandomDataUtils.randomNumeric(4);
        String plCostRecoveryThreshold = RandomDataUtils.randomNumeric(4);
        String plDefaultCurrency = "XUA";
        String plLocalTimeZone = "Alaska Standard Time (AST)";
        String plStatus = "Active";
        plantsPage.createPlant(locationName, plDuns, plCostRecoveryThreshold, plDefaultCurrency, plLocalTimeZone, plStatus, organizationName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantsPage.searchPlantByLocationName(locationName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayPlStatus = plantsPage.isPlantDisplayed(locationName);
        softAssert.assertTrue(displayPlStatus, "Failed to create new plant with business organization");
        String updatePlantName = locationName + "_EDIT";
        plantsPage.editPlant(updatePlantName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantsPage.clearLocationNameTextField();
        plantsPage.searchPlantByLocationName(updatePlantName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean updatedPlantDisplayStatus = plantsPage.isPlantDisplayed(updatePlantName);
        softAssert.assertTrue(updatedPlantDisplayStatus, "Failed to update plant");
        plantsPage.deletePlant();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        plantsPage.clearLocationNameTextField();
        plantsPage.searchPlantByLocationName(updatePlantName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        plantsPage.clickOnSearchIcon();
        boolean isPlantDeleted = plantsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isPlantDeleted, "Failed to delete plant");
        homePage.clickOnEnterprise();
        businessOrganizationsPage.clickOnBusinessOrganizationsTab();
        businessOrganizationsPage.clearOrganizationNameTextField();
        businessOrganizationsPage.searchOrganizationByName(organizationName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        businessOrganizationsPage.deleteOrganization();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        softAssert.assertAll();
    }

}